From 848907f6c369878b627f8390213d3495830d8ed3 Mon Sep 17 00:00:00 2001
From: Smeulf <smeulf@team-mediaportal.com>
Date: Sat, 8 Oct 2011 00:18:54 +0200
Subject: [PATCH] UPnP library : Force address for outgoing multicast request in MulticastOption of the socket

---
 .../UPnP/Infrastructure/Utils/NetworkHelper.cs     |   10 +++++-----
 1 files changed, 5 insertions(+), 5 deletions(-)

diff --git a/MediaPortal/Source/Core/UPnP/Infrastructure/Utils/NetworkHelper.cs b/MediaPortal/Source/Core/UPnP/Infrastructure/Utils/NetworkHelper.cs
index 598f45d..9841576 100644
--- a/MediaPortal/Source/Core/UPnP/Infrastructure/Utils/NetworkHelper.cs
+++ b/MediaPortal/Source/Core/UPnP/Infrastructure/Utils/NetworkHelper.cs
@@ -271,7 +271,7 @@ namespace UPnP.Infrastructure.Utils
         try
         {
           socket.SetSocketOption(SocketOptionLevel.IP, SocketOptionName.AddMembership,
-              new MulticastOption(UPnPConsts.SSDP_MULTICAST_ADDRESS_V4));
+              new MulticastOption(UPnPConsts.SSDP_MULTICAST_ADDRESS_V4,address));
           socket.SetSocketOption(SocketOptionLevel.IP, SocketOptionName.PacketInformation, true);
         }
         catch (SocketException e)
@@ -283,13 +283,13 @@ namespace UPnP.Infrastructure.Utils
         {
           // We only receive in those multicast groups where we joined
           socket.SetSocketOption(SocketOptionLevel.IPv6, SocketOptionName.AddMembership,
-              new IPv6MulticastOption(UPnPConsts.SSDP_MULTICAST_ADDRESS_V6_NODE_LOCAL));
+              new IPv6MulticastOption(UPnPConsts.SSDP_MULTICAST_ADDRESS_V6_NODE_LOCAL,address.ScopeId));
           socket.SetSocketOption(SocketOptionLevel.IPv6, SocketOptionName.AddMembership,
-              new IPv6MulticastOption(UPnPConsts.SSDP_MULTICAST_ADDRESS_V6_LINK_LOCAL));
+              new IPv6MulticastOption(UPnPConsts.SSDP_MULTICAST_ADDRESS_V6_LINK_LOCAL, address.ScopeId));
           socket.SetSocketOption(SocketOptionLevel.IPv6, SocketOptionName.AddMembership,
-              new IPv6MulticastOption(UPnPConsts.SSDP_MULTICAST_ADDRESS_V6_SITE_LOCAL));
+              new IPv6MulticastOption(UPnPConsts.SSDP_MULTICAST_ADDRESS_V6_SITE_LOCAL, address.ScopeId));
           socket.SetSocketOption(SocketOptionLevel.IPv6, SocketOptionName.AddMembership,
-              new IPv6MulticastOption(UPnPConsts.SSDP_MULTICAST_ADDRESS_V6_GLOBAL));
+              new IPv6MulticastOption(UPnPConsts.SSDP_MULTICAST_ADDRESS_V6_GLOBAL, address.ScopeId));
           socket.SetSocketOption(SocketOptionLevel.IPv6, SocketOptionName.PacketInformation, true);
         }
         catch (SocketException e)
-- 
1.7.4.msysgit.0

